import numpy
from ScrumPy.Data import DataSets

import BuildLP

def Changers(ds,lim=1e-06):
	rv = []
	for cname in ds.cnames:
		col = ds.GetCol(cname)
		if abs(max(col)-min(col))>lim:
			rv.append(cname)
	return rv
	

def LipidScan(m,lo=0.0,hi=1.0, np=100):
        
	ds = DataSets.DataSet()
	lp = BuildLP.BiomassLP(m)
	
	lp.SetFluxBounds({"GLYCEROL_Cyto_tx":(0,5)})

	for t in numpy.arange(lo,hi,hi/np):
		lp.SetFixedFlux({"TAG_Exp_tx":-t})
		lp.Solve(False)
		if lp.GetStatusMsg() == "optimal":
			sol = lp.GetPrimSol()
			ds.UpdateFromDic(sol)

	ds.MulCol("TAG_Exp_tx",k=-1)
	return ds
