from Util import Set
import ObsBiomass

def BuildLP(m):

    lp = m.GetLP()
    lp.SetObjective(m.sm.cnames)
    return lp
    

def ReverLP(m):
    """ lp object of m with all reactions reversible """

    oldrevprops = {}
    oldrevprops.update(m.sm.RevProps)

    for r in m.sm.RevProps:
        if not "_tx" in r:
            m.sm.RevProps[r] = "<>"
    lp = LP.lp(m)

    m.sm.RevProps.update(oldrevprops)
    return lp


def ExternLP(m):
    """ lp object representing the external sm.
        hideous hack - do it properly in the LP  module"""

    sm   = m.sm
    m.sm = m.smexterns
    lp   = ReverLP(m)
    m.sm =  sm

    return lp


def BiomassLP(m):
    """ lp object, constrained to biomass fluxes defined in ObsBiomass """

    fd = ObsBiomass.FluxDic(m)
    
    unwanted = Set.Complement(filter(lambda x: x.endswith("_bm_tx"), m.sm.cnames), fd.keys())
    for tx in unwanted:
        fd[tx]=0    
        
    lp = BuildLP(m)        
    lp.SetFixedFlux(fd)
    
    return lp


def DarkBiomassLP(m):

    lp = BiomassLP(m)
    
    lp.ClearFluxConstraint("Chrysolaminaran_bm_tx")
    lp.SetFixedFlux({"Photon_tx": 0})
    
    return lp


def NullBiomassLP(m):

    lp = BuildLP(m)

    for tx in filter(lambda x: x.endswith("_bm_tx"), m.sm.cnames):
        lp.SetFixedFlux({tx:0})

    return lp
