from ScrumPy.Bioinf import Biomass

Biomass.MolWts.Syns["Chrysolaminaran"]  = "GLC"
Biomass.MolWts.MolWts["Chrysolaminaran"] = 180.16
Biomass.MolWts.MolWts["CHLOROPHYLL-A"]  = 893.50
Biomass.MolWts.MolWts["CPD1F-133"]      = 600.88
Biomass.MolWts.MolWts["ALPHA-TOCOPHEROL"]= 430.71
Biomass.MolWts.MolWts["ASCORBATE"]      = 174.11
Biomass.MolWts.MolWts["NIACINAMIDE"]    = 122.13
Biomass.MolWts.MolWts["RIBOFLAVIN"]     = 375.36
Biomass.MolWts.MolWts["THIAMINE"]       = 265.35
Biomass.MolWts.MolWts["TAG"]            = 936.32

prot = Biomass.Composition(
    0.030789449,{
        "CYS_Cyto" : 0.015984016,
        "L-ASPARTATE_Cyto" : 0.0589410589, 
        "ASN_Cyto" : 0.037962038,
        "GLT_Cyto" : 0.0609390609,
        "GLN_Cyto" : 0.040959041,
        "SER_Cyto" : 0.0839160839,
        "GLY_Cyto" : 0.0639360639, 
        "THR_Cyto" : 0.0609390609,
        "HIS_Cyto" : 0.024975025,
        "L-ALPHA-ALANINE_Cyto" : 0.0849150849,
        "TYR_Cyto" : 0.025974026,
        "ARG_Cyto" : 0.0619380619,
        "VAL_Cyto" : 0.0679320679,
        "TRP_Cyto" : 0.013986014,
        "MET_Cyto" : 0.022977023,
        "PHE_Cyto" : 0.036963037,
        "ILE_Cyto" : 0.044955045,
        "LEU_Cyto" : 0.0939060939,
        "LYS_Cyto" : 0.045954046,
        "PRO_Cyto" : 0.0519480519        
        }
    )

Chlorophyll = Biomass.Composition(
    0.0366094058, {
        "CHLOROPHYLL-A_Cyto": 1.0,
##        "CPD1F-133_Cyto":0.4,
        }
    )

nuc = Biomass.Composition(
    0.041866141, {
        "AMP_Cyto" : 0.115,
        "CMP_Cyto" : 0.135,
        "GMP_Cyto" : 0.135,
        "TMP_Cyto" : 0.115,
        "UMP_Cyto" : 0.115,
        'DAMP_Cyto': 0.115,
        'DCMP_Cyto': 0.135,
        'DGMP_Cyto': 0.135,
        }
    )

##cellwallpoly =  Biomass.Composition(
##    0.0,
##    {
##        "CELLULOSE_Cyto" : 0.5,
##        "XYLAN_Cyto"     : 0.5,
##    }
##)

starch =    Biomass.Composition(
    0.6013329579,
    {
#         "Starch_Plas": 1,#0.0,
         "Chrysolaminaran_Cyto":1
    }
)

##lignin = Biomass.Composition(
##    0.00,{
##        "CONIFERYL-ALCOHOL_Cyto" : 0.0,
##        "COUMARYL-ALCOHOL_Cyto" : 0.0, 
##        "SINAPYL-ALCOHOL_Cyto" : 0.0,
##        }
##    )


lipid = Biomass.Composition(
    0.2407772458, {
        "LINOLEIC_ACID_Cyto":0.32,
        "PALMITATE_Cyto":0.32,
        "TAG_Cyto":0.36
        }
    )


sol = Biomass.Composition(
##    0.0642072656
    0.0202759786, {
        "ALPHA-TOCOPHEROL_Cyto":0.01,
        "ASCORBATE_Cyto":	0.66,#0.66 originally,increased to 0.8 compensate for thiamine
        "NIACINAMIDE_Cyto":	0.18,
        "RIBOFLAVIN_Cyto":	0.01,
##        "THIAMINE_Cyto":	0.0025344973,#0.14
##        "ash_Cyto": 0.0283488219,
    }
)




All = Biomass.Composition(
    1.0, #
    {
        "starch": starch,
        "prot" : prot,
        "nuc" : nuc,
        #"cellwallpoly" : cellwallpoly,
        #"lignin" :lignin,
        "Chlorophyll" : Chlorophyll,
        "lipid":lipid,
        "sol" : sol
    }
)



StripComp = lambda s: s.rsplit("_",1)[0]


def FluxDic(model):
    rv = {}
    for met in All.GetLeaves():
        xp = Biomass.WhatExports(model,met)

        if xp == None:
            print ("no tx for ", met)
        else:
            rv[xp] = -All.MolsOf(met,StripComp)
    return rv

def FluxBound(model,low=1.0,high=100.0):
    rv = {}
    fd = FluxDic(model)
    for r in fd.keys():
        rv[r] = (fd[r]*high,fd[r]*low)

    return rv

def MolToGram(fd,sol):
    rv = {}
    for r in fd.keys():
        met = r.split('_bm_tx')[0]
        if met in Biomass.MolWts.MolWts.keys():
                rv[met] = sol[r]*Biomass.MolWts.MolWts[met]
        else:
                rv[met] = "Mol Wt not known"
    return rv
